#ifndef _PSYSTEM_H_
#define _PSYSTEM_H_

typedef struct {
 GLuint num;      // pocet castic systemu

 vec3 s_pos;      // poloha systemu
 GLfloat s_speed; // rychlost castic systemu
 GLfloat s_time;  // dlzka "zivota" castic systemu
 GLfloat s_size;  // velkost castic systemu

 GLuint tex_id;   // identifikator textury castic systemu
 vec4 s_color;    // farba castic systemu

 vec3 *pos;     // zoznam poloh jednotlivych castic
 GLfloat *rot;  // zoznam natocenia jednotlivych castic
 vec3 *speed;   // zoznam rychlosti jednotlivych castic na osiach X,Y,Z
 GLfloat *time; // zoznam dlziek "zivota" jednotlivych castic

 vec3 F; // externa sila posobiaca na castice systemu
} particle_system;

// trieda premennych a funkcii pre pracu so systemom castic
class Cpsystem {
public:
 Cpsystem() { ps=NULL; } // konstruktor
 virtual ~Cpsystem() {   // destruktor
  if (ps!=NULL) { DELETEA(ps->pos); DELETEA(ps->speed); DELETEA(ps->time); DELETEA(ps->rot); }
  DELETEP(ps);
 }

 particle_system *ps; // system castic

 GLfloat mvmat[16]; // billboarding castic systemu
 vec3 mx,my,s;

 vec4 c; // pre upravu farby castice

 GLfloat f; // pomocna premenna

 // vytvorenie systemu
 int create(GLuint N,GLfloat SPEED,GLfloat TIME,GLfloat SIZE,GLuint TID);
 // poloha systemu
 void set_pos(vec3 P) { if (ps!=NULL) { ps->s_pos=P; loopi(ps->num) ps->pos[i]=P; } }
 // farba systemu
 void set_color(vec4 C) { if (ps!=NULL) { ps->s_color=C; } }
 // externa sila posobiaca na castice systemu
 void set_force(vec3 F) { if (ps!=NULL) { ps->F=F; } }
};

// trieda premennych a funkcii pre pracu so systemom castic - ohen
class Cps_fire : public Cpsystem {
public:
 Cps_fire() {};          // konstruktor
 virtual ~Cps_fire() {}; // destruktor

 // reset "zivota" castice systemu
 void reset_timer(int I);
 // priebeh "zivota" systemu
 void update(GLfloat dT);
 // vykreslenie systemu
 void draw(float M);
private:
 // rychlosti jednotlivych castic systemu
 float noise(float S) { return(sin(ranged_random(0.0f,TWO_PI))*S); }
};

// trieda premennych a funkcii pre pracu so systemom castic - para
class Cps_steam : public Cpsystem {
public:
 Cps_steam() {};          // konstruktor
 virtual ~Cps_steam() {}; // destruktor

 // smer emitacie castic
 void set_emmiter(vec3 E) { emi=E; }

 // reset "zivota" castice systemu
 void reset_timer(int I);
 // priebeh "zivota" systemu
 void update(GLfloat dT);
 // vykreslenie systemu
 void draw(float M);
private:
 vec3 emi;

 // rychlosti jednotlivych castic systemu
 float noise(float S) { return(S); }
};

#endif
