// hlavickove subory *******************************************************
#include "includes.h"
// vlastny .h subor
#include "interface.h"

// uplynuty cas medzi aktualnym a povodnym casovym okamihom (s)
GLfloat difTime;

// instancia triedy CTexture - praca s texturami
CTexture texture;
// ciselne oznacenia textur - nie su totozne s identifikatormi nahratych textur v CTexture!
// vyhradene oznacenia:
// 0 - standardna textura
// 1 - zameriavaci kriz
// 2 - svietidlo
// 3 - zbran
// 4-9 - diery po gulkach
// 10-(MAX_TEX_NUM-1) - ostatne textury
// ostatne oznacenia textur su v rozsahu <10;MAX_TEX_NUM-1>
GLuint tid[MAX_TEX_NUM];
// ciselne oznacenia lightmap - nie su totozne s identifikatormi vytvorenych lightmap v CTexture!
// oznacenia lightmap su v rozsahu <0;MAX_LM_NUM-1>
GLuint lmid[MAX_LM_NUM];

CMath3d m3d; // instancia triedy CMath3d - praca s matematikou

mat16 avamat; // matica pre ulozenie transformacnej matice Avatara, ktory
              // je reprezentovany MD3 modelom, tato matica sa naplni pocas
              // vykreslenia hornej casti (torso) modelu - transformacia sceny je
              // zosynchronizovana s transformaciou hornej casti Avatara

vec3 zeroV(0.0f,0.0f,0.0f);

// indikatory dostupnosti OpenGL rozsireni *********************************
bool glextVBO=false,glextDRE=false,glextOQ=false,glextTR=false,glextFBO=false,glextDS=false,
     glextTF=false,glextBE=false,glextCM=false,glextNP2=false,glextTC=false,glextTE=false,
     glextMT=false,glextD3=false,glextAF=false,glextVP2=false,glextVP3=false,glextPP=false,
     glextMDA=false,glextTE3=false,glextTE4=false,glextVP=false,glextFP=false,glextGLSL=false,
     glextGM=false,glextNVFB=false;

// GL_ARB_vertex_buffer_object
PFNGLGENBUFFERSARBPROC       glGenBuffers_      =NULL;
PFNGLBINDBUFFERARBPROC       glBindBuffer_      =NULL;
PFNGLMAPBUFFERARBPROC        glMapBuffer_       =NULL;
PFNGLUNMAPBUFFERARBPROC      glUnmapBuffer_     =NULL;
PFNGLBUFFERDATAARBPROC       glBufferData_      =NULL;
PFNGLBUFFERSUBDATAARBPROC    glBufferSubData_   =NULL;
PFNGLDELETEBUFFERSARBPROC    glDeleteBuffers_   =NULL;
PFNGLGETBUFFERSUBDATAARBPROC glGetBufferSubData_=NULL;

// GL_ARB_multitexture
PFNGLACTIVETEXTUREARBPROC       glActiveTexture_      =NULL;
PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTexture_=NULL;
PFNGLMULTITEXCOORD2FARBPROC     glMultiTexCoord2f_    =NULL;
PFNGLMULTITEXCOORD3FARBPROC     glMultiTexCoord3f_    =NULL;
PFNGLMULTITEXCOORD4FARBPROC     glMultiTexCoord4f_    =NULL;

// GL_ARB_vertex_program, GL_ARB_fragment_program
PFNGLGENPROGRAMSARBPROC              glGenPrograms_             =NULL;
PFNGLDELETEPROGRAMSARBPROC           glDeletePrograms_          =NULL;
PFNGLBINDPROGRAMARBPROC              glBindProgram_             =NULL;
PFNGLPROGRAMSTRINGARBPROC            glProgramString_           =NULL;
PFNGLGETPROGRAMIVARBPROC             glGetProgramiv_            =NULL;
PFNGLPROGRAMENVPARAMETER4FARBPROC    glProgramEnvParameter4f_   =NULL;
PFNGLPROGRAMENVPARAMETER4FVARBPROC   glProgramEnvParameter4fv_  =NULL;
PFNGLPROGRAMLOCALPARAMETER4FVARBPROC glProgramLocalParameter4fv_=NULL;
PFNGLENABLEVERTEXATTRIBARRAYARBPROC  glEnableVertexAttribArray_ =NULL;
PFNGLDISABLEVERTEXATTRIBARRAYARBPROC glDisableVertexAttribArray_=NULL;
PFNGLVERTEXATTRIBPOINTERARBPROC      glVertexAttribPointer_     =NULL;

// GL_EXT_gpu_program_parameters
PFNGLPROGRAMENVPARAMETERS4FVEXTPROC   glProgramEnvParameters4fv_  =NULL;
PFNGLPROGRAMLOCALPARAMETERS4FVEXTPROC glProgramLocalParameters4fv_=NULL;

// GL_ARB_occlusion_query
PFNGLGENQUERIESARBPROC        glGenQueries_       =NULL;
PFNGLDELETEQUERIESARBPROC     glDeleteQueries_    =NULL;
PFNGLBEGINQUERYARBPROC        glBeginQuery_       =NULL;
PFNGLENDQUERYARBPROC          glEndQuery_         =NULL;
PFNGLGETQUERYIVARBPROC        glGetQueryiv_       =NULL;
PFNGLGETQUERYOBJECTIVARBPROC  glGetQueryObjectiv_ =NULL;
PFNGLGETQUERYOBJECTUIVARBPROC glGetQueryObjectuiv_=NULL;

// GL_EXT_framebuffer_object
PFNGLBINDRENDERBUFFEREXTPROC        glBindRenderbuffer_       =NULL;
PFNGLDELETERENDERBUFFERSEXTPROC     glDeleteRenderbuffers_    =NULL;
PFNGLGENFRAMEBUFFERSEXTPROC         glGenRenderbuffers_       =NULL;
PFNGLRENDERBUFFERSTORAGEEXTPROC     glRenderbufferStorage_    =NULL;
PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC  glCheckFramebufferStatus_ =NULL;
PFNGLBINDFRAMEBUFFEREXTPROC         glBindFramebuffer_        =NULL;
PFNGLDELETEFRAMEBUFFERSEXTPROC      glDeleteFramebuffers_     =NULL;
PFNGLGENFRAMEBUFFERSEXTPROC         glGenFramebuffers_        =NULL;
PFNGLFRAMEBUFFERTEXTURE2DEXTPROC    glFramebufferTexture2D_   =NULL;
PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC glFramebufferRenderbuffer_=NULL;
PFNGLGENERATEMIPMAPEXTPROC          glGenerateMipmap_         =NULL;

// GL_ARB_shading_language_100, GL_ARB_shader_objects, GL_ARB_fragment_shader, GL_ARB_vertex_shader
PFNGLCREATEPROGRAMOBJECTARBPROC       glCreateProgramObject_ =NULL;
PFNGLDELETEOBJECTARBPROC              glDeleteObject_        =NULL;
PFNGLUSEPROGRAMOBJECTARBPROC          glUseProgramObject_    =NULL;
PFNGLCREATESHADEROBJECTARBPROC        glCreateShaderObject_  =NULL;
PFNGLSHADERSOURCEARBPROC              glShaderSource_        =NULL;
PFNGLCOMPILESHADERARBPROC             glCompileShader_       =NULL;
PFNGLGETOBJECTPARAMETERIVARBPROC      glGetObjectParameteriv_=NULL;
PFNGLATTACHOBJECTARBPROC              glAttachObject_        =NULL;
PFNGLGETINFOLOGARBPROC                glGetInfoLog_          =NULL;
PFNGLLINKPROGRAMARBPROC               glLinkProgram_         =NULL;
PFNGLGETUNIFORMLOCATIONARBPROC        glGetUniformLocation_  =NULL;
PFNGLUNIFORM4FVARBPROC                glUniform4fv_          =NULL;
PFNGLUNIFORM1IARBPROC                 glUniform1i_           =NULL;
PFNGLUNIFORM4FARBPROC                 glUniform4f_           =NULL;
PFNGLUNIFORMMATRIX4FVARBPROC          glUniformMatrix4fv_    =NULL;

// GL_EXT_draw_range_elements
PFNGLDRAWRANGEELEMENTSEXTPROC glDrawRangeElements_=NULL;

// GL_EXT_blend_minmax
PFNGLBLENDEQUATIONEXTPROC glBlendEquation_=NULL;

// GL_EXT_multi_draw_arrays
PFNGLMULTIDRAWARRAYSEXTPROC   glMultiDrawArrays_=NULL;
PFNGLMULTIDRAWELEMENTSEXTPROC glMultiDrawElements_=NULL;

// pocet texturovacich jednotiek Texel-Pipelines
GLint maxTexelUnits;

void *getprocaddress(const char *name)
{
 return(SDL_GL_GetProcAddress(name));
}

// test dostupnosti OpenGL rozsireni ***************************************
void checkextensions(void)
{
 const char *renderer=(const char *) glGetString(GL_RENDERER);
 const char *vendor=(const char *) glGetString(GL_VENDOR);
 const char *version=(const char *) glGetString(GL_VERSION);

 printf("Renderer: %s\n",renderer);
 printf("Vendor: %s\n",vendor);
 printf("Version: %s\n",version);

 // retazec s podporovanymi rozsireniami grafickej karty
 const char *exts=(const char *) glGetString(GL_EXTENSIONS);

 if (strstr(exts,"GL_EXT_texture_env_combine") || strstr(exts,"GL_ARB_texture_env_combine")) {
  glextTE=true;
  if (strstr(exts,"GL_ATI_texture_env_combine3")) glextTE3=true;
  if (strstr(exts,"GL_NV_texture_env_combine4")) glextTE4=true;
  if (strstr(exts,"GL_EXT_texture_env_dot3") || strstr(exts,"GL_ARB_texture_env_dot3")) glextD3=true;
 }
 else printf("No texture_env_combine extension!\n");
 if (strstr(exts,"GL_ARB_multitexture")) {
  glActiveTexture_      =(PFNGLACTIVETEXTUREARBPROC)       getprocaddress("glActiveTextureARB");
  glClientActiveTexture_=(PFNGLCLIENTACTIVETEXTUREARBPROC) getprocaddress("glClientActiveTextureARB");
  glMultiTexCoord2f_    =(PFNGLMULTITEXCOORD2FARBPROC)     getprocaddress("glMultiTexCoord2fARB");
  glMultiTexCoord3f_    =(PFNGLMULTITEXCOORD3FARBPROC)     getprocaddress("glMultiTexCoord3fARB");
  glMultiTexCoord4f_    =(PFNGLMULTITEXCOORD4FARBPROC)     getprocaddress("glMultiTexCoord4fARB");
  glextMT=true;
 }
 else printf("No multitexture extension!\n");
 if (strstr(exts,"GL_ARB_vertex_buffer_object")) {
  glGenBuffers_      =(PFNGLGENBUFFERSARBPROC)       getprocaddress("glGenBuffersARB");
  glBindBuffer_      =(PFNGLBINDBUFFERARBPROC)       getprocaddress("glBindBufferARB");
  glMapBuffer_       =(PFNGLMAPBUFFERARBPROC)        getprocaddress("glMapBufferARB");
  glUnmapBuffer_     =(PFNGLUNMAPBUFFERARBPROC)      getprocaddress("glUnmapBufferARB");
  glBufferData_      =(PFNGLBUFFERDATAARBPROC)       getprocaddress("glBufferDataARB");
  glBufferSubData_   =(PFNGLBUFFERSUBDATAARBPROC)    getprocaddress("glBufferSubDataARB");
  glDeleteBuffers_   =(PFNGLDELETEBUFFERSARBPROC)    getprocaddress("glDeleteBuffersARB");
  glGetBufferSubData_=(PFNGLGETBUFFERSUBDATAARBPROC) getprocaddress("glGetBufferSubDataARB");
  glextVBO=true;
 }
 else printf("No vertex_buffer_object extension!\n"); // slow large geometry
 if (strstr(exts,"GL_EXT_draw_range_elements")) {
  glDrawRangeElements_=(PFNGLDRAWRANGEELEMENTSEXTPROC) getprocaddress("glDrawRangeElementsEXT");
  glextDRE=true;
 }
 if (strstr(exts,"GL_EXT_multi_draw_arrays")) {
  glMultiDrawArrays_  =(PFNGLMULTIDRAWARRAYSEXTPROC)   getprocaddress("glMultiDrawArraysEXT");
  glMultiDrawElements_=(PFNGLMULTIDRAWELEMENTSEXTPROC) getprocaddress("glMultiDrawElementsEXT");
  glextMDA=true;
 }
 if (strstr(exts,"GL_ARB_texture_float") || strstr(exts,"GL_ATI_texture_float")) { glextTF=true; }
 if (strstr(exts,"GL_NV_float_buffer")) { glextNVFB=true; }
 if (strstr(exts,"GL_EXT_framebuffer_object")) {
  glBindRenderbuffer_       =(PFNGLBINDRENDERBUFFEREXTPROC)        getprocaddress("glBindRenderbufferEXT");
  glDeleteRenderbuffers_    =(PFNGLDELETERENDERBUFFERSEXTPROC)     getprocaddress("glDeleteRenderbuffersEXT");
  glGenRenderbuffers_       =(PFNGLGENFRAMEBUFFERSEXTPROC)         getprocaddress("glGenRenderbuffersEXT");
  glRenderbufferStorage_    =(PFNGLRENDERBUFFERSTORAGEEXTPROC)     getprocaddress("glRenderbufferStorageEXT");
  glCheckFramebufferStatus_ =(PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC)  getprocaddress("glCheckFramebufferStatusEXT");
  glBindFramebuffer_        =(PFNGLBINDFRAMEBUFFEREXTPROC)         getprocaddress("glBindFramebufferEXT");
  glDeleteFramebuffers_     =(PFNGLDELETEFRAMEBUFFERSEXTPROC)      getprocaddress("glDeleteFramebuffersEXT");
  glGenFramebuffers_        =(PFNGLGENFRAMEBUFFERSEXTPROC)         getprocaddress("glGenFramebuffersEXT");
  glFramebufferTexture2D_   =(PFNGLFRAMEBUFFERTEXTURE2DEXTPROC)    getprocaddress("glFramebufferTexture2DEXT");
  glFramebufferRenderbuffer_=(PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC) getprocaddress("glFramebufferRenderbufferEXT");
  glGenerateMipmap_         =(PFNGLGENERATEMIPMAPEXTPROC)          getprocaddress("glGenerateMipmapEXT");
  glextFBO=true;
 }
 else printf("No framebuffer_object support!\n"); // slow reflective water
 if (strstr(exts,"GL_ARB_occlusion_query")) {
  GLint bits;
  glGetQueryiv_=(PFNGLGETQUERYIVARBPROC) getprocaddress("glGetQueryivARB");
  glGetQueryiv_(GL_SAMPLES_PASSED_ARB,GL_QUERY_COUNTER_BITS_ARB,&bits);
  if (bits) {
   glGenQueries_=       (PFNGLGENQUERIESARBPROC)        getprocaddress("glGenQueriesARB");
   glDeleteQueries_=    (PFNGLDELETEQUERIESARBPROC)     getprocaddress("glDeleteQueriesARB");
   glBeginQuery_=       (PFNGLBEGINQUERYARBPROC)        getprocaddress("glBeginQueryARB");
   glEndQuery_=         (PFNGLENDQUERYARBPROC)          getprocaddress("glEndQueryARB");
   glGetQueryObjectiv_= (PFNGLGETQUERYOBJECTIVARBPROC)  getprocaddress("glGetQueryObjectivARB");
   glGetQueryObjectuiv_=(PFNGLGETQUERYOBJECTUIVARBPROC) getprocaddress("glGetQueryObjectuivARB");
   glextOQ=true;
  }
 }
 if (strstr(exts,"GL_ARB_vertex_program") && strstr(exts,"GL_ARB_fragment_program")) {
  glGenPrograms_=             (PFNGLGENPROGRAMSARBPROC)              getprocaddress("glGenProgramsARB");
  glDeletePrograms_=          (PFNGLDELETEPROGRAMSARBPROC)           getprocaddress("glDeleteProgramsARB");
  glBindProgram_=             (PFNGLBINDPROGRAMARBPROC)              getprocaddress("glBindProgramARB");
  glProgramString_=           (PFNGLPROGRAMSTRINGARBPROC)            getprocaddress("glProgramStringARB");
  glGetProgramiv_=            (PFNGLGETPROGRAMIVARBPROC)             getprocaddress("glGetProgramivARB");
  glProgramEnvParameter4f_=   (PFNGLPROGRAMENVPARAMETER4FARBPROC)    getprocaddress("glProgramEnvParameter4fARB");
  glProgramEnvParameter4fv_=  (PFNGLPROGRAMENVPARAMETER4FVARBPROC)   getprocaddress("glProgramEnvParameter4fvARB");
  glProgramLocalParameter4fv_=(PFNGLPROGRAMLOCALPARAMETER4FVARBPROC) getprocaddress("glProgramLocalParameter4fvARB");
  glEnableVertexAttribArray_= (PFNGLENABLEVERTEXATTRIBARRAYARBPROC)  getprocaddress("glEnableVertexAttribArrayARB");
  glDisableVertexAttribArray_=(PFNGLDISABLEVERTEXATTRIBARRAYARBPROC) getprocaddress("glDisableVertexAttribArrayARB");
  glVertexAttribPointer_=     (PFNGLVERTEXATTRIBPOINTERARBPROC)      getprocaddress("glVertexAttribPointerARB");
  glextVP=glextFP=true;
  if (strstr(exts,"GL_ARB_shading_language_100") && strstr(exts,"GL_ARB_shader_objects") &&
      strstr(exts,"GL_ARB_vertex_shader") && strstr(exts,"GL_ARB_fragment_shader")) {
   glCreateProgramObject_=       (PFNGLCREATEPROGRAMOBJECTARBPROC)  getprocaddress("glCreateProgramObjectARB");
   glDeleteObject_=              (PFNGLDELETEOBJECTARBPROC)         getprocaddress("glDeleteObjectARB");
   glUseProgramObject_=          (PFNGLUSEPROGRAMOBJECTARBPROC)     getprocaddress("glUseProgramObjectARB");
   glCreateShaderObject_=        (PFNGLCREATESHADEROBJECTARBPROC)   getprocaddress("glCreateShaderObjectARB");
   glShaderSource_=              (PFNGLSHADERSOURCEARBPROC)         getprocaddress("glShaderSourceARB");
   glCompileShader_=             (PFNGLCOMPILESHADERARBPROC)        getprocaddress("glCompileShaderARB");
   glGetObjectParameteriv_=      (PFNGLGETOBJECTPARAMETERIVARBPROC) getprocaddress("glGetObjectParameterivARB");
   glAttachObject_=              (PFNGLATTACHOBJECTARBPROC)         getprocaddress("glAttachObjectARB");
   glGetInfoLog_=                (PFNGLGETINFOLOGARBPROC)           getprocaddress("glGetInfoLogARB");
   glLinkProgram_=               (PFNGLLINKPROGRAMARBPROC)          getprocaddress("glLinkProgramARB");
   glGetUniformLocation_=        (PFNGLGETUNIFORMLOCATIONARBPROC)   getprocaddress("glGetUniformLocationARB");
   glUniform4fv_=                (PFNGLUNIFORM4FVARBPROC)           getprocaddress("glUniform4fvARB");
   glUniform1i_=                 (PFNGLUNIFORM1IARBPROC)            getprocaddress("glUniform1iARB");
   glUniform4f_=                 (PFNGLUNIFORM4FARBPROC)            getprocaddress("glUniform4fARB");
   glUniformMatrix4fv_=          (PFNGLUNIFORMMATRIX4FVARBPROC)     getprocaddress("glUniformMatrix4fvARB");
   glextGLSL=true;
  } else printf("No GLSL extension!\n");
 }
 else printf("No ShaderPrograms extension!\n");
 if (strstr(exts,"GL_NV_vertex_program2_option")) { glextVP2=true; }
 if (strstr(exts,"GL_NV_vertex_program3")) { glextVP3=true; }
 if (strstr(exts,"GL_EXT_gpu_program_parameters")) {
  glProgramEnvParameters4fv_  =(PFNGLPROGRAMENVPARAMETERS4FVEXTPROC)   getprocaddress("glProgramEnvParameters4fvEXT");
  glProgramLocalParameters4fv_=(PFNGLPROGRAMLOCALPARAMETERS4FVEXTPROC) getprocaddress("glProgramLocalParameters4fvEXT");
  glextPP=true;
 }
 if (strstr(exts,"GL_EXT_texture_rectangle") || strstr(exts,"GL_ARB_texture_rectangle")) {
  glextTR=true;
 }
 else if (glextMT && glextVP && glextFP) printf("No texture_rectangle support!\n"); // no fullscreen shaders
 if (strstr(exts,"GL_EXT_packed_depth_stencil") || strstr(exts,"GL_NV_packed_depth_stencil")) {
  glextDS=true;
 }
 if (strstr(exts,"GL_EXT_blend_minmax")) {
  glBlendEquation_=(PFNGLBLENDEQUATIONEXTPROC) getprocaddress("glBlendEquationEXT");
  glextBE=true;
 }
 if (strstr(exts,"GL_ARB_texture_cube_map")) { glextCM=true; }
 else printf("No texture_cube_map support!\n"); // no reflective glass
 if (strstr(exts,"GL_ARB_texture_non_power_of_two")) { glextNP2=true; }
 else printf("No texture_non_power_of_two support!\n");
 if (strstr(exts,"GL_EXT_texture_compression_s3tc")) { glextTC=true; }
 if (strstr(exts,"GL_EXT_texture_filter_anisotropic")) { glextAF=true; }
 if (strstr(exts,"GL_SGIS_generate_mipmap")) { glextGM=true; }

 // kazda graficka karta ma aspon 1 texturovaciu jednotku
 maxTexelUnits=1;
 // pocet texturovacich jednotiek
 glGetIntegerv(GL_MAX_TEXTURE_UNITS_ARB,&maxTexelUnits);
 printf("Pocet texturovacich jednotiek: %u\n",maxTexelUnits);
}

// konstruktor *************************************************************
CInterface::CInterface()
{
 fog_onoff=false;       // zap/vyp hmly
 lighting_onoff=false;  // zap/vyp osvetlenia
 help_onoff=false;      // zap/vyp vypisu helpu
 pause_onoff=false;     // zap/vyp casovo zavisleho pohybu objektov
 normals_onoff=false;   // zap/vyp vykreslovania normal
 polygon_onoff=false;   // zap/vyp vykreslovania hran
 flashlight_onoff=0.0f; // zap/vyp svietidla

 // farba hmly = farba pozadia
 //fogcolor[0]=0.5f; fogcolor[1]=0.6f; fogcolor[2]=0.7f; fogcolor[3]=1.0f;
 fogcolor[0]=0.0f; fogcolor[1]=0.0f; fogcolor[2]=0.0f; fogcolor[3]=1.0f;

 // parametre 1 materialu
 loopi(1) {
  material[i].amb[0]=0.5f; material[i].amb[1]=0.5f;
  material[i].amb[2]=0.5f; material[i].amb[3]=1.0f;
  material[i].dif[0]=0.9f; material[i].dif[1]=0.9f;
  material[i].dif[2]=0.9f; material[i].dif[3]=1.0f;
  material[i].spe[0]=1.0f; material[i].spe[1]=1.0f;
  material[i].spe[2]=1.0f; material[i].spe[3]=1.0f;
  material[i].amb_dif[0]=0.5f; material[i].amb_dif[1]=0.5f;
  material[i].amb_dif[2]=0.5f; material[i].amb_dif[3]=1.0f;
  material[i].emi[0]=1.0f; material[i].emi[1]=1.0f;
  material[i].emi[2]=1.0f; material[i].emi[3]=1.0f;
  material[i].shi=128.0f;
  material[i].transp=0.0f;
  material[i].sillum[0]=0.0f; material[i].sillum[1]=0.0f;
  material[i].sillum[2]=0.0f; material[i].sillum[3]=1.0f;
 }
 // parametre 2 svetiel
 loopi(2) {
  light[i].amb[0]=0.5f; light[i].amb[1]=0.5f;
  light[i].amb[2]=0.5f; light[i].amb[3]=1.0f;
  light[i].dif[0]=0.9f; light[i].dif[1]=0.9f;
  light[i].dif[2]=0.9f; light[i].dif[3]=1.0f;
  light[i].spe[0]=1.0f; light[i].spe[1]=1.0f;
  light[i].spe[2]=1.0f; light[i].spe[3]=1.0f;
  light[i].pos[0]=-10.0f; light[i].pos[1]=1.0f;
  light[i].pos[2]=12.0f; light[i].pos[3]=1.0f;
  // pos[3]=1.0f - vsesmerove svetlo, 0.0f - smerove svetlo
  light[i].spot[0]=0.0f;
  light[i].spot[1]=-1.0f;
  light[i].spot[2]=0.0f;
 }
 light[1].pos[2]=3.0f;

 // stavy OpenGL stavoveho stroja
 OGL_state[0]=0; OGL_state[1]=0;

 // velkost zameriavacieho kriza
 crosshairSize=50.0f;

 // priradenie ciselnych oznaceni texturam
 // vyhradene oznacenia:
 // 0 - standardna textura
 // 1 - zameriavaci kriz
 // 2 - svietidlo
 // 3 - zbran
 // 4-9 - diery po gulkach
 // 10-(MAX_TEX_NUM-1) - ostatne textury
 // ostatne oznacenia textur su v rozsahu <10;MAX_TEX_NUM-1>
 loopi(MAX_TEX_NUM) tid[i]=i;

 // priradenie ciselnych oznaceni lightmapam
 // 0-(MAX_LM_NUM-1) - lightmapy
 loopi(MAX_LM_NUM) lmid[i]=i;

 // pocet snimkov za sekundu
 actFPS=0;
 // historia FPS
 loopi(FPSHISTORY) fpshistory[i]=1;

 was_jump=false; // Avatar je na zemi
}

// destruktor **************************************************************
CInterface::~CInterface()
{
 //DELETEP(physics_wall);
 //DELETEP(physics_glass);
}

// inicializacia OpenGL - nastavenie parametrov OpenGL sceny ***************
int CInterface::OGL_initialize(void)
{
 // test dostupnosti OpenGL rozsireni
 checkextensions();

 // STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ --

 // zasobnik farieb bude vymazavany farbou hmly = farba pozadia
 glClearColor(fogcolor[0],fogcolor[1],fogcolor[2],fogcolor[3]);
 // zasobnik hlbky bude vymazavany nastavenim na 1.0f
 glClearDepth(1.0f);
 // pomocny zasobnik bude vymazavany nastavenim na 0
 glClearStencil(0);

 glDepthFunc(GL_LESS);    // typ porovnavacej funkcie pre urcenie Z-vzdialenosti
 glEnable(GL_DEPTH_TEST); // testovanie Z-vzdialenosti

 glDisable(GL_CULL_FACE); // poradie, v ktorom budu definovane vrcholy objektov
 glFrontFace(GL_CCW);     // reprezentovat privratene, resp. odvratene plochy,
 glCullFace(GL_BACK);     // CCW - proti smeru hod. ruciciek, CW - v smere hod. ruciciek
 glEnable(GL_CULL_FACE);  // odvratene plochy sa nebudu spracovavat

 // hmla
 if (fog_onoff) {
  glFogi(GL_FOG_MODE,GL_LINEAR);  // typ
  glFogf(GL_FOG_DENSITY,0.25f);   // hustota
  glHint(GL_FOG_HINT,GL_NICEST);  // kvalita
  glFogfv(GL_FOG_COLOR,fogcolor); // farba
  glEnable(GL_FOG);
 }

 // Gourand (jemne) tienovanie, kvalita tienovania
 //glShadeModel(GL_SMOOTH);
 //glHint(GL_POLYGON_SMOOTH_HINT,GL_NICEST);

 // vyhladzovanie ciar, kvalita vyhladzovania
 //glEnable(GL_LINE_SMOOTH);
 //glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);

 // trojuholniky budu vyplnene
 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

 // posun Z-hodnot predtym ako sa ulozia do DepthBuffera
 glPolygonOffset(-1.0f,-1.0f);

 // celoobrazovkove vyhladzovanie
 if (fsaa) glEnable(GL_MULTISAMPLE);

 // modulacia textur osvetlenim, vysledna farba bodu = farba z textury + osvetlenie
 // resp. farba z textury + farba definovana pomocou glColor()
 glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);

 // standardna farba - biela
 glColor4f(1.0f,1.0f,1.0f,1.0f);

 // texturovanie je standardne zapnute
 glEnable(GL_TEXTURE_2D);

 // stencil test je standardne zapnuty
 glEnable(GL_STENCIL_TEST);

 // kvalitnejsie perspektivne vypocty a korekcie
 //glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
/*
 // vseobecny material objektov
 glMaterialfv(GL_FRONT,GL_AMBIENT,material[0].amb);
 glMaterialfv(GL_FRONT,GL_DIFFUSE,material[0].dif);
 glMaterialfv(GL_FRONT,GL_SPECULAR,material[0].spe);
 glMaterialfv(GL_FRONT,GL_EMISSION,material[0].emi);
 glMaterialf(GL_FRONT,GL_SHININESS,material[0].shi);
 // farba bude mat vplyv iba na 'diffuse' zlozku materialu*/
 glColorMaterial(GL_FRONT,GL_DIFFUSE);
 // pre Gourandove svetelne vypocty bude pouzity material priradeny objektu,
 // ktory bude ale stale ovplyvneny farbou zadavanou prikazom glColor()
 glEnable(GL_COLOR_MATERIAL);

 // nastavenie parametrov 1. OpenGL svetla
 glLightfv(GL_LIGHT0,GL_AMBIENT,light[0].amb);
 glLightfv(GL_LIGHT0,GL_DIFFUSE,light[0].dif);
 glLightfv(GL_LIGHT0,GL_SPECULAR,light[0].spe);
 glLightfv(GL_LIGHT0,GL_POSITION,light[0].pos);
 glEnable(GL_LIGHT0); // ON
 // nastavenie parametrov 2. OpenGL svetla
 glLightfv(GL_LIGHT1,GL_AMBIENT,light[1].amb);
 glLightfv(GL_LIGHT1,GL_DIFFUSE,light[1].dif);
 glLightfv(GL_LIGHT1,GL_SPECULAR,light[1].spe);
 glLightfv(GL_LIGHT1,GL_POSITION,light[1].pos);
 glEnable(GL_LIGHT1); // ON
 if (lighting_onoff) glEnable(GL_LIGHTING);
 else glDisable(GL_LIGHTING);
 // svetlo sa pocita len pre privratene strany
 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,0);
 // svetelne vypocty su lokalne
 glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,1.0f);

 // inicializacia Avatara
 avatar.init();
 enemy_avatar.init();
 avatar.set_rotate(0.0f,90.0f,0.0f);
 enemy_avatar.actpos.set(6.0f,0.6f,0.0f);
 enemy_avatar.set_rotate(0.0f,140.0f,0.0f);

 // inicializacia vykreslovania
 frontend.init();

 // INICIALIZACIA SCENY INICIALIZACIA SCENY INICIALIZACIA SCENY ------------

 printf("----------------------------------------------------------\n");

 // inicializacia fontu
 if (text.init("data/font/font.png")) {
  printf("Chyba inicializacie fontu!\n"); return(1);
 }

 // nahratie standardnej textury
 if (texture.load2D(tid[0],"data/textures/default/empty.png",T_LINEAR)) {
  printf("Chyba nahratia stdandardnej textury!\n"); return(1);
 }

 // nahratie textury zameriavacieho kriza
 if (texture.load2D(tid[1],"data/gfx/crosshair0.png",T_LINEAR|T_CLAMP)) {
  printf("Chyba nahratia textury zameriavacieho kriza!\n"); return(1);
 }

 // nahratie textury svietidla
 if (texture.load2D(tid[2],"data/gfx/flashlight0.png",T_LINEAR|T_CLAMP)) {
  printf("Chyba nahratia textury svietidla!\n"); return(1);
 }

 // nahratie textury castice
 if (texture.load2D(tid[8],"data/gfx/fire.png",T_LINEAR|T_CLAMP)) {
  printf("Chyba nahratia textury castice!\n"); return(1);
 }

 // nahratie textury castice
 if (texture.load2D(tid[9],"data/gfx/smoke.png",T_LINEAR|T_CLAMP)) {
  printf("Chyba nahratia textury castice!\n"); return(1);
 }

 if (fire[0].create(30,1.5f,0.5f,0.25f,texture.tex_id[tid[8]]) ||
     fire[1].create(30,1.5f,0.5f,0.25f,texture.tex_id[tid[8]])) {
  printf("Chyba inicializacie ohna!\n"); return(1);
 }
 fire[0].set_pos(vec3(32.75f,-3.25f,11.93f));
 fire[0].set_color(vec4(0.9f,0.3f,0.05f,1.0f));
 fire[0].set_force(vec3(0.0f,5.0f,0.0f));
 fire[1].set_pos(vec3(32.75f,-3.25f,27.99f));
 fire[1].set_color(vec4(0.9f,0.3f,0.05f,1.0f));
 fire[1].set_force(vec3(0.0f,5.0f,0.0f));

 if (steam[0].create(40,1.0f,1.0f,0.3f,texture.tex_id[tid[9]])) {
  printf("Chyba inicializacie pary!\n"); return(1);
 }
 steam[0].set_pos(vec3(31.7f,-5.1f,10.5f));
 steam[0].set_color(vec4(0.8f,0.8f,0.8f,1.0f));
 steam[0].set_force(vec3(0.0f,5.0f,0.0f));
 steam[0].set_emmiter(vec3(-5.0f,0.0f,1.0f));

 // nahratie shaderov
 if (glextMT&&glextVP&&glextFP) {
  // Shader Programy
  printf("Shader programy: ");
  if (fl_vp.PRGload("shaders/fl.vp")) return(1);
  if (fl_fp.PRGload("shaders/fl.fp")) return(1);
  if (nm_fl_vp.PRGload("shaders/nm_fl.vp")) return(1);
  if (nm_fl_fp.PRGload("shaders/nm_fl.fp")) return(1);
  if (decal_vp.PRGload("shaders/decal.vp")) return(1);
  if (decal_fp.PRGload("shaders/decal.fp")) return(1);
  printf("\n");
  // GLSL shadery
  if (glextGLSL) {
   printf("GLSL shadery: ");
   if (glsl_shader.GLSLload(0,"shaders/proj_glsl.vp","shaders/proj_glsl.fp")) return(1);
   glsl_shader.GLSLon(0);
   glsl_shader.GLSLuniformI(0,"base_tex_unit",0);
   glsl_shader.GLSLuniformI(0,"normal_tex_unit",1);
   glsl_shader.GLSLoff();
   if (glsl_shader.GLSLload(1,"shaders/lighting_glsl.vp","shaders/lighting_glsl.fp")) return(1);
   glsl_shader.GLSLon(1);
   glsl_shader.GLSLuniformI(1,"base_tex_unit",0);
   glsl_shader.GLSLoff();
   printf("\n");
  }
 }

 // nacitanie vsetkych trojuholnikov
 if (backend.tris_add()) {
  printf("Chyba nacitania trojuholnikov!\n"); return(1);
 }

 // inicializacia platna
 //physics_cloth.init();

 // inicializacia muru
 physics_wall=new CPhWall();

 // inicializacia sklanenej platne
 physics_glass=new CPhGlass();

 // priprava zrkadiel a odrazenych trojuholnikov
 backend.mirrors_prepare();

 // inicializacia MD3 postavy
 player.init(0);
 enemy.init(1);

 return(0);
}

// aktualny pocet fps, minimalny a maximalny pocet fps *********************
void CInterface::getfpshistory(GLuint &ACT,GLuint &MIN,GLuint &MAX)
{
 fpstotal=fpshistory[FPSHISTORY-1]; MIN=fpstotal; MAX=fpstotal;
 loopi(FPSHISTORY-1) {
  fpstotal+=fpshistory[i];
  if (fpshistory[i]>MIN) MIN=fpshistory[i];
  if (fpshistory[i]<MAX) MAX=fpshistory[i];
 }
 ACT=(1000*FPSHISTORY)/fpstotal; MIN=1000/MIN; MAX=1000/MAX;
}

// nastartovanie casovaca **************************************************
void CInterface::resettime(void)
{
 // aktualny casovy okamih (ms)
 actTime=(GLuint) SDL_GetTicks();
 // povodny casovy okamih (ms)
 oldTime=actTime;
 // pocet uplynutych milisekund
 millis=actTime-oldTime;
 // pomocne premenne
 fpsdelay=0; fpserror=0;

 // uplynuty cas medzi aktualnym a povodnym casovym okamihom (s)
 difTime=((GLfloat) millis)/1000.0f;

 // pocitadlo snimkov
 frames=0;
 // historia fps
 fpspos=0; fpstotal=0;
 // minimalny a maximalny pocet snimkov za sekundu
 minfps=0; maxfps=0;
}

// aktualizacia casovaca ***************************************************
// 1s=1000ms
// Uint32 SDL_GetTicks() vracia pocet ms od startu SDL,
// po 49.7 dnoch dojde k prekroceniu 32bit limitu a pocitadlo sa vynuluje
void CInterface::updatetime(void)
{
 //SDL_Delay(20);

 // aktualny casovy okamih (ms)
 actTime=(GLuint) SDL_GetTicks();
 // aktualny casovy okamih nemoze byt "starsi" ako povodny casovy okamih
 if (actTime<oldTime) actTime=oldTime;
 // pocet uplynutych milisekund
 millis=actTime-oldTime;
 // uprava poctu uplynutych milisekund
 fpsdelay=1000/MAXFPS-millis;
 if (fpsdelay<0) fpserror=0; // ak MAXFPS=200 => millis>=5
 else {
  fpserror+=1000%MAXFPS;
  if (fpserror>=MAXFPS) { fpserror-=MAXFPS; ++fpsdelay; }
  if (fpsdelay>0) {
   SDL_Delay(fpsdelay);
   actTime+=(GLuint) fpsdelay;
   millis=actTime-oldTime;
  }
 }

 // uplynuty cas medzi aktualnym a povodnym casovym okamihom (s)
 difTime=((GLfloat) millis)/1000.0f;
 oldTime=actTime;

 // pocitadlo snimkov
 frames++;
 // aktualizacia historie fps
 fpshistory[fpspos++]=(GLuint) max(1,min(1000,(int) millis));
 // po naplneni pola historie fps sa vypocita actFPS
 if (fpspos>=FPSHISTORY) {
  fpspos=0;
  // pocet snimkov za sekundu, minimalny a maximalny pocet snimkov za sekundu
  //actFPS=1000/millis;
  getfpshistory(actFPS,minfps,maxfps);
 }
}

// vykreslenie OpenGL sceny ************************************************
void CInterface::OGL_draw(void)
{
 // vymazanie zasobnika farieb a hlbky
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT|GL_STENCIL_BUFFER_BIT);
 //glClear(GL_DEPTH_BUFFER_BIT);

 // transformacia polohy svetla podla polohy Avatara
 //light[0].pos[0]=-avatar.posx;
 //light[0].pos[1]=-avatar.posy;
 //light[0].pos[2]=-avatar.posz;
 // umiestenenie svetla na preddefinovanu poziciu
 //glLightfv(GL_LIGHT0,GL_POSITION,light[0].pos);
 //glLightfv(GL_LIGHT1,GL_POSITION,light[1].pos);
 // bod na polohe svetelneho zdroja
 //glPointSize(10.0f);
 //glBegin(GL_POINTS); glVertex3fv(light[0].pos); glEnd();

 // zmena animacie MD3 postavy
 if (avatar.isFire1) { player.setAnim(-1,TORSO_ATTACK); }
 if (avatar.is_jumping()) {
  if (!was_jump) { was_jump=true; player.setAnim(LEGS_JUMP,-1); }
 }
 else {
  was_jump=false;
  if (avatar.is_crouching()) {
   if (avatar.is_moving()) { player.setAnim(LEGS_WALKCR,-1); }
   else { player.setAnim(LEGS_IDLECR,-1); }
  }
  else if (avatar.is_moving())  { player.setAnim(LEGS_WALK,-1); }
       else { player.setAnim(LEGS_IDLE,-1); }
 }
 // ak Avatar striela - zacne animacia strelby, premenna stopaction=0

 // modelview matica je vo vychodzom stave - jednotkova (identity)

 // vykreslenie postavy - ide o tzv. skryte (dummy) vykreslenie,
 // pri ktorom sa aplikuju prislusne transformacie, ale
 // k vykresleniu objektov nedojde, v tomto pripade sa iba naplni
 // transformacna matica - avamat
 // v pripade ak sa vykresluje hrac, neaplikuje sa strelba
 player.draw(avatar.actpos,avatar.get_angle(),zeroV,vec3(2.0f,0.0f,0.0f),0);
 // vektor smerujuci dopredu
 avatar.targetV.set(avamat[2],avamat[6],avamat[10]);
 // vektor smerujuci doprava
 avatar.rightV.set(avamat[0],avamat[4],avamat[8]);
 // poloha oci Avatara
 avatar.eyepos.set(avamat[12],avamat[13],avamat[14]);
 avatar.eyepos+=avatar.actpos;
 // translacia sa vykona pomocou glTranslate a nie pomocou matice avamat
 avamat[12]=0.0f; avamat[13]=0.0f; avamat[14]=0.0f;
 // poloha ustia hlavne upravena podla polohy Avatara
 fireP+=avatar.actpos;

 // vytvorenie odtlackov - je znama poloha ustia hlavne a dopredu smerujuci vektor,
 // v tomto pripade su vypocty realizovane v OBJECT space ------------------
 player.fire(fireP,fireV,avatar.rightV,avatar.isFire1);

 glPushMatrix();              // ulozenie modelview matice
 glLoadMatrixf(avamat.get()); // modelview matica = avamat
 // posun sceny na poziciu oci Avatara
 glTranslatef(avatar.eyepos.x,avatar.eyepos.y,avatar.eyepos.z);

 // od tohto okamihu su vsetky vypocty realizovane vo WORLD space ----------
/*
 // vykreslenie suradnicovych osi avamat
 glPushMatrix();
 glDisable(GL_TEXTURE_2D);
 glLineWidth(5.0f);
 glBegin(GL_LINES);
  glColor3f(1.0f,0.5f,0.5f);
  glVertex3f(-avatar.eyepos.x,-avatar.eyepos.y,-avatar.eyepos.z);
  glVertex3f(-avatar.eyepos.x+avamat[0],-avatar.eyepos.y+avamat[4],-avatar.eyepos.z+avamat[8]);
  glColor3f(0.5f,1.0f,0.5f);
  glVertex3f(-avatar.eyepos.x,-avatar.eyepos.y,-avatar.eyepos.z);
  glVertex3f(-avatar.eyepos.x+avamat[1],-avatar.eyepos.y+avamat[5],-avatar.eyepos.z+avamat[9]);
  glColor3f(0.5f,0.5f,1.0f);
  glVertex3f(-avatar.eyepos.x,-avatar.eyepos.y,-avatar.eyepos.z);
  glVertex3f(-avatar.eyepos.x+avamat[2],-avatar.eyepos.y+avamat[6],-avatar.eyepos.z+avamat[10]);
 glEnd();
 glLineWidth(1.0f);
 glEnable(GL_TEXTURE_2D);
 glColor3f(1.0f,1.0f,1.0f);
 glPopMatrix();
*/
 //glEnable(GL_STENCIL_TEST);

 // vykreslenie zrkadiel a odrazenych trojuholnikov
 frontend.mirrors_on(flashlight_onoff,avatar.actpos);
 // vykreslenie odrazu postavy v zrkadle - kompletna postava - neaplikuje sa strelba
 player.draw(avatar.actpos,avatar.get_angle(),zeroV,vec3(2.0f,0.0f,0.0f),1);
  // vykreslenie ohna
 fire[0].draw(-1.0f); fire[1].draw(-1.0f);
 // vykreslenie pary
 steam[0].draw(-1.0f);
 frontend.mirrors_off();

 //glStencilFunc(GL_ALWAYS,1,1); // stencil porovnavacia funkcia
 //glStencilOp(GL_KEEP,GL_KEEP,GL_REPLACE);

 // vykreslenie zbrane
 //bool a=!stopaction;
 //weapon->draw(avatar.eyepos,avatar.targetV,avatar.rightV,avatar.isFire1);

 //glStencilFunc(GL_NOTEQUAL,1,1); // stencil porovnavacia funkcia
 //glStencilOp(GL_KEEP,GL_KEEP,GL_KEEP);

 // vykreslenie vsetkych trojuholnikov
 frontend.tris_draw(flashlight_onoff,avatar.actpos);

 // vykreslenie dier po gulkach
 player.drawDecals();

 // vykreslenie aktivneho objemu rebrikov
 //loopvk(ladders) ladders[k].draw();

 // vykreslenie platna
 //physics_cloth.draw(avatar.eyepos,avatar.targetV,avatar.isFire1);

 // vykreslenie muru
 physics_wall->draw(fireP,fireV,avatar.isFire1,stopaction,difTime);

 // vykreslenie sklenenej platne
 physics_glass->draw(fireP,fireV,avatar.isFire1,stopaction,difTime);

 // vykreslenie trojuholnikov nacitanych z 3ds suboru
 //backend.tris_draw();

 //glDisable(GL_STENCIL_TEST);

 // vykreslenie postavy - iba nohy (lower) a zbran (weapon) - neaplikuje sa strelba
 player.draw(avatar.actpos,avatar.get_angle(),zeroV,vec3(2.0f,0.0f,0.0f),2);

 // vykreslenie protihraca - aplikuje sa strelba
 // transformacia fireP a fireV z OBJECT do WORLD space je robena rucne
 fireP-=avatar.eyepos; fireP=avamat*fireP; fireV=avamat*fireV;
 // protihrac sa vykresluje vo WORLD space (je transformovany maticou avamat)
 if (enemy.draw(enemy_avatar.actpos,enemy_avatar.get_angle(),fireP,fireV,1)==1) {
  // protihrac bol zasiahnuty
  if (!stopaction) enemy.setAnim(BOTH_DEATH1,BOTH_DEATH1);
 }

 // vykreslenie ohna
 fire[0].draw(1.0f); fire[1].draw(1.0f);
 // vykreslenie pary
 steam[0].draw(1.0f);

 glPopMatrix(); // obnova modelview matice

 stopaction=1; // Avatar nemoze strielat az do ukoncenia animacie "strelba"

 // vykreslenie head-up obrazovky
 drawhud();
}

// vykreslenie head-up obrazovky *******************************************
void CInterface::drawhud(void)
{
 // ulozenie potrebnych atributov
 glPushAttrib(GL_LIGHTING_BIT|GL_DEPTH_BUFFER_BIT);

 glDisable(GL_LIGHTING);   // vypnutie osvetlenia
 glDisable(GL_DEPTH_TEST); // vypnutie testu hlbky
 glEnable(GL_BLEND);       // zapnutie priesvitnosti

 glMatrixMode(GL_PROJECTION); // projekcna matica
 glPushMatrix();              // ulozenie
 glLoadIdentity();            // reset

 // nastavenie pravouhleho premietania - obrati poradie CCW na CW
 glOrtho(0.0f,(GLfloat) scr_w,(GLfloat) scr_h,0.0f,-1.0f,1.0f);

 glMatrixMode(GL_MODELVIEW); // modelview matica
 glPushMatrix();             // ulozenie
 glLoadIdentity();           // reset

 // vykreslenie textu ------------------------------------------------------

 // funkcia pre vypocet priesvitnosti
 glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA);

 // farba textu
 glColor4f(0.8f,0.8f,0.0f,1.0f);
 // pripojenie textury so znakmi
 glBindTexture(GL_TEXTURE_2D,text.texture_id);

 glPushMatrix(); // ulozenie modelview matice
 // velkost textu
 glScalef(0.5f,0.5f,1.0f);
 // vypis poctu fps
 text.drawf(10.0f,10.0f,"%u",actFPS);
 glPopMatrix(); // obnova modelview matice

 glPushMatrix(); // ulozenie modelview matice
 // velkost textu
 glScalef(0.5f,0.5f,1.0f);
 // poloha Avatara
 text.drawf(10.0f,40.0f,"%.1f %.1f %.1f",avatar.actpos.x,avatar.actpos.y,avatar.actpos.z);
 glPopMatrix(); // obnova modelview matice

 // vykreslenie zameriavacieho kriza ---------------------------------------

 glPushMatrix(); // ulozenie modelview matice

 // funkcia pre vypocet priesvitnosti
 glBlendFunc(GL_ONE,GL_ONE);

 // farba zameriavacieho kriza
 glColor4f(1.0f,1.0f,1.0f,1.0f);
 // zameriavaci kriz na stred okna
 glTranslatef((GLfloat) scr_w2-crosshairSize/2.0f,
              (GLfloat) scr_h2-crosshairSize/2.0f,0.0f);
 // pripojenie textury zameriavacieho kriza
 glBindTexture(GL_TEXTURE_2D,texture.tex_id[tid[1]]);
 // stvoruholnik
 glBegin(GL_QUADS); // poradie vrcholov je CW pretoze pre vykreslenie je pouzite glOrtho()
  glTexCoord2f(0.0f,0.0f); glVertex3f(0.0f,0.0f,0.0f);
  glTexCoord2f(0.0f,1.0f); glVertex3f(0.0f,crosshairSize,0.0f);
  glTexCoord2f(1.0f,1.0f); glVertex3f(crosshairSize,crosshairSize,0.0f);
  glTexCoord2f(1.0f,0.0f); glVertex3f(crosshairSize,0.0f,0.0f);
 glEnd();

 glPopMatrix(); // obnova modelview matice

 // vykreslenie napovedy ---------------------------------------------------

 //if (help_onoff) {
 // glPushMatrix(); // ulozenie modelview matice
 //
 // glPopMatrix(); // obnova modelview matice
 //}

 // nastavenie standardnej farby - biela
 glColor4f(1.0f,1.0f,1.0f,1.0f);

 glDisable(GL_BLEND); // vypnutie priesvitnosti
 glPopAttrib();       // vyber ulozenych atributov - LIGHTING, DEPTH_BUFFER

 glPopMatrix(); // obnova modelview matice
 glMatrixMode(GL_PROJECTION);
 glPopMatrix(); // obnova projection matice

 // aktualna je vzdy modelview matica
 glMatrixMode(GL_MODELVIEW);
}

// casovo zavisla uprava objektov, resp. sceny *****************************
void CInterface::OGL_idle(void)
{
 //if (pause_onoff) {
 fire[0].update(difTime);
 fire[1].update(difTime);

 steam[0].update(difTime);
 //}
}

// vyplnene trojuholniky/iba hrany *****************************************
void CInterface::change_polygon_mode(void)
{
 if (polygon_onoff) {
  polygon_onoff=false;
  // trojuholniky budu vyplnene
  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
 }
 else {
  polygon_onoff=true;
  // budu vykreslene iba hrany trojuholnikov
  glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
 }
}

// zap/vyp svietidla *******************************************************
void CInterface::change_flashlight_onoff(void)
{
 if (flashlight_onoff==0.0f) flashlight_onoff=1.2f;
 else flashlight_onoff=0.0f;
}
